.386
.model flat,stdcall
option casemap:none

include tws.inc

.code

start:

	invoke	GetModuleHandle,NULL
	mov		hInstance, eax
	invoke	GetCommandLine
	invoke	InitCommonControls
	mov		CommandLine, eax
	invoke	WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
	invoke	ExitProcess, eax


WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	invoke	LoadBitmap, hInstance, 100
	invoke	CreatePatternBrush, eax
	mov		wc.hbrBackground, eax
	mov		wc.lpszMenuName, NULL
	mov		wc.lpszClassName, offset ClassName
	invoke	LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke	LoadCursor,NULL, IDC_HAND
	mov		wc.hCursor,eax
	invoke	RegisterClassEx, addr wc
	invoke	CreateDialogParam, hInstance, IDD_DIALOG, NULL, addr WndProc, NULL
	invoke	ShowWindow, hWnd, SW_SHOWNORMAL
	invoke	UpdateWindow, hWnd
	.while TRUE
		invoke	GetMessage, addr msg, NULL, 0, 0
		.BREAK .if !eax
		invoke	TranslateMessage, addr msg
		invoke	DispatchMessage, addr msg
	.endw
	mov		eax, msg.wParam
	ret

WinMain endp


WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		
		push	hWin
		pop		hWnd
		
		invoke	ExtCreateRegion, NULL, 14736, addr rgndata
		invoke	SetWindowRgn, hWin, eax, TRUE
		
		invoke	LoadMenu, hInstance, IDM_MENU
		invoke	GetSubMenu, eax, 0
		mov		hMenu, eax
		
	.elseif eax==WM_COMMAND
		
		mov		eax, wParam
		and		eax, 0ffffh
		
		.if eax==IDM_FILE_EXIT
			 
			invoke SendMessage,hWin,WM_CLOSE,0,0
			
		.elseif eax==IDM_HELP_ABOUT
			
			mov		mbp.cbSize, sizeof MSGBOXPARAMS
			m2m		mbp.hwndOwner, hWin
			m2m		mbp.hInstance, hInstance
			mov		mbp.lpszText, offset AboutMsg
			mov		mbp.lpszCaption, offset AppName
			mov		mbp.dwStyle, MB_USERICON 
			mov		mbp.lpszIcon, IDC_MAINICON
			invoke	MessageBoxIndirect, addr mbp
			
		.endif
		
		
	.elseif eax==WM_LBUTTONDOWN
		
		invoke	SendMessage, hWin, WM_NCLBUTTONDOWN, HTCAPTION, lParam
		
	.elseif eax==WM_CONTEXTMENU
		
		mov		eax, lParam
		mov		edx, eax
		and		eax, 0ffffh
		shr		edx, 16
		invoke	TrackPopupMenu, hMenu, TPM_LEFTALIGN + TPM_RIGHTBUTTON, eax, edx, 0, hWnd, 0
		
	.elseif eax==WM_CLOSE
		
		invoke DestroyWindow, hWin
		
	.elseif uMsg==WM_DESTROY
		
		invoke PostQuitMessage, NULL
		
	.else
		
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
		
	.endif
	
	xor    eax,eax
	ret

WndProc endp

end start
